#pragma once

template <class ElementT>
class CAutoArray
{
private:
	ElementT *m_pElements;
	int m_size;

public:
	CAutoArray(int size)
	{
		_Construct(size);
	}
	CAutoArray()
	{
		m_size = 0;
	}
	~CAutoArray()
	{
		delete[] m_pElements;
	}
	void Create(int size)
	{
		_ASSERT( m_size == 0 );
		_Construct(size);
	}
	ElementT& operator [](int n)
	{
		_ASSERT( 0 <= n && n < m_size );
		return m_pElements[n];
	}
	const ElementT& operator [](int n) const
	{
		_ASSERT( 0 <= n && n < m_size );
		return m_pElements[n];
	}
	int size() const { return m_size; }

private:
	void _Construct(int size)
	{
		_ASSERT( size > 0 );
		m_size = size;
		m_pElements = new ElementT[size];
	}
};
