#include "StdAfx.h"
#include <stdlib.h>
#include <stdio.h>
#include <tchar.h>
#include "commonservice.h"
#include "cs_conv.h"

CCommonService CCommonService::m_singleton;
const LPCSTR CCommonService::SYSTEM_MSG[] = {
	NMS_SYSTEM_EXIT,
	NMS_SYSTEM_DEBUG_PRINT,
	NMS_SYSTEM_ENUMPROTOCOLS,
	NMS_SYSTEM_ENUMMODULES,
	NMS_SYSTEM_GETPLUGININFO,
	NMS_SYSTEM_CONNECTION_CREATE,
	NMS_SYSTEM_CONNECTION_DELETE,
	NMS_SYSTEM_CONNECTION_GETINFO,
	NMS_SYSTEM_CONNECTION_SETINFO,
	NMS_SYSTEM_CONNECTION_ENUM,
	NMS_SYSTEM_CONNECTION_MEMBERS_ADD,
	NMS_SYSTEM_CONNECTION_MEMBERS_REMOVE,
	NMS_SYSTEM_CONNECTION_MEMBERS_GETINFO,
	NMS_SYSTEM_CONNECTION_MEMBERS_SETINFO,
	NMS_SYSTEM_CONNECTION_MEMBERS_ENUM,
	NMS_SYSTEM_CONNECTION_MEMBERS_BEGINUPDATE,
	NMS_SYSTEM_CONNECTION_MEMBERS_ENDUPDATE,
	NMS_SYSTEM_CONNECTION_GROUPS_ADD,
	NMS_SYSTEM_CONNECTION_GROUPS_REMOVE,
	NMS_SYSTEM_CONNECTION_GROUPS_GETINFO,
	NMS_SYSTEM_CONNECTION_GROUPS_SETINFO,
	NMS_SYSTEM_CONNECTION_GROUPS_ENUM,
	NMS_SYSTEM_CONNECTION_GROUPS_BEGINUPDATE,
	NMS_SYSTEM_CONNECTION_GROUPS_ENDUPDATE,
	NMS_SYSTEM_SESSION_CREATE,
	NMS_SYSTEM_SESSION_DELETE,
	NMS_SYSTEM_SESSION_GETINFO,
	NMS_SYSTEM_SESSION_SETINFO,
	NMS_SYSTEM_SESSION_ENUM,
	NMS_SYSTEM_SESSION_MEMBERS_ADD,
	NMS_SYSTEM_SESSION_MEMBERS_REMOVE,
	NMS_SYSTEM_SESSION_MEMBERS_GETINFO,
	NMS_SYSTEM_SESSION_MEMBERS_SETINFO,
	NMS_SYSTEM_SESSION_MEMBERS_ENUM,
	NMS_SYSTEM_SESSION_MEMBERS_BEGINUPDATE,
	NMS_SYSTEM_SESSION_MEMBERS_ENDUPDATE,
	NMS_SYSTEM_SESSION_SENDMESSAGE,
	NMS_SYSTEM_SESSION_RECEIVEMESSAGE,
	NMS_SYSTEM_FILESESSION_CREATE,
	NMS_SYSTEM_FILESESSION_DELETE,
	NMS_SYSTEM_FILESESSION_GETINFO,
	NMS_SYSTEM_FILESESSION_SETINFO,
	NMS_SYSTEM_FILESESSION_ENUM,
//	NMS_SYSTEM_CONNECTION_UISERVICE_MEMBER_ENUM,
//	NMS_SYSTEM_CONNECTION_UISERVICE_GROUP_ENUM,
//	NMS_SYSTEM_ADDIN_UISERVICE_MAIN_ENUM,
//	NMS_SYSTEM_ADDIN_UISERVICE_MEMBER_ENUM,
//	NMS_SYSTEM_ADDIN_UISERVICE_GROUP_ENUM,
//	NMS_SYSTEM_ADDIN_UISERVICE_TAB_ENUM,
	NMS_UI_MESSAGEBOX,
	NMS_UI_NOTIFY
};


CCommonService::CCommonService()
: m_bValid(false)
{
	DEBUG_CODE( md_hLog = NULL );
}

CCommonService::~CCommonService(void)
{
}

//*******************************************************************
// {
//*******************************************************************

HNsmService CCommonService::CreateService(LPCTSTR ServiceName, TNsmServiceProc ProcAddr)
{
	if( ! m_bValid ) return NULL;
	return InitInfo()->CreateService(ServiceName, ProcAddr);
}

HNsmService CCommonService::GetService(LPCTSTR ServiceName)
{
	if( ! m_bValid ) return NULL;
	return InitInfo()->GetService(ServiceName);
}

int CCommonService::CallService(HNsmService ServiceHandle, WPARAM wParam, LPARAM lParam)
{
	if( ! m_bValid ) return NULL;
	return InitInfo()->CallService(ServiceHandle, wParam, lParam);
}

HNsmEvent CCommonService::CreateEvent(LPCTSTR EventName)
{
	if( ! m_bValid ) return NULL;
	return InitInfo()->CreateEvent(EventName);
}

HNsmEvent CCommonService::GetEvent(LPCTSTR EventName)
{
	if( ! m_bValid ) return NULL;
	return InitInfo()->GetEvent(EventName);
}

int CCommonService::NotifyEvent(HNsmEvent EventHandle, WPARAM wParam, LPARAM lParam)
{
	if( ! m_bValid ) return NULL;
	return InitInfo()->NotifyEvent(EventHandle, wParam, lParam);
}

int CCommonService::HookEvent(LPCTSTR EventName, TNsmEventProc ProcAddr)
{
	if( ! m_bValid ) return NULL;
	return InitInfo()->HookEvent(EventName, ProcAddr);
}

int CCommonService::UnhookEvent(LPCTSTR EventName, TNsmEventProc ProcAddr)
{
	if( ! m_bValid ) return NULL;
	return InitInfo()->UnhookEvent(EventName, ProcAddr);
}

//*******************************************************************
// g
//*******************************************************************

// bZ[WCallService
int CCommonService::CallService(LPCTSTR msgname, WPARAM wParam, LPARAM lParam)
{
DEBUG_CODE( DebugLog(msgname) );

	return CallService(GetService(msgname), wParam, lParam);
}

// bZ[WCallServiceăLbV
int CCommonService::CallService(int no, LPCTSTR msgname, WPARAM wParam, LPARAM lParam)
{
	HNsmService hService = GetService(msgname);
	m_serviceCache[no] = hService;
	return CallService(hService, wParam, lParam);
}

//*******************************************************************
// [U
//*******************************************************************

// [U擾
int CCommonService::GetUserName(HNsmConnection ConnectionID, LPWSTR lpBuf, size_t nBufferLen)
{
	TNsmConnectionInfo nci;
	TNsmInfo ni;
	int ret;

	memset(&nci, 0, sizeof(nci));
	nci.cbSize = sizeof(nci);
	nci.lpInfo = &ni;
	nci.nInfoKey = NMCI_USER_NAME;
	ni.lpBuffer = (LPBYTE)lpBuf;
	ni.nBufferSize = nBufferLen;

	ret = CallServiceCache(ID_NMS_SYSTEM_CONNECTION_GETINFO, (WPARAM)ConnectionID, (LPARAM)&nci);
	if( ret <= 0 && nBufferLen > 0 ) lpBuf[0] = '\0';

	return ret;
}

// [Uݒ
void CCommonService::SetUserName(HNsmConnection hConnectionID, LPCWSTR lpUserName)
{
	SetConnectionInfo(hConnectionID, NMCI_USER_NAME, lpUserName);
}

// [UXe[^X擾
int CCommonService::GetUserStatus(HNsmConnection hConnectionID)
{
	return GetConnectionInfoInt(hConnectionID, NMCI_USER_STATUS);
}

// [UXe[^Xݒ
void CCommonService::SetUserStatus(HNsmConnection hConnectionID, int nUserStatus)
{
	SetConnectionInfo(hConnectionID, NMCI_USER_STATUS, nUserStatus);
}

//*******************************************************************
// o
//*******************************************************************

void CCommonService::DeleteAllConnectionMembers(HNsmConnection hConnection)
{
	member_list list;
	member_list::iterator i;

	GetConnectionMemberList(list, hConnection);
	for( i = list.begin(); i != list.end(); ++i ){
		DeleteConnectionMember(hConnection, i->c_str());
	}
}

void CCommonService::ConnectionMemberBeginUpdate(HNsmConnection hConnection)
{
	CallServiceCache(ID_NMS_SYSTEM_CONNECTION_MEMBERS_BEGINUPDATE, hConnection, 0);
}

void CCommonService::ConnectionMemberEndUpdate(HNsmConnection hConnection)
{
	CallServiceCache(ID_NMS_SYSTEM_CONNECTION_MEMBERS_ENDUPDATE, hConnection, 0);
}

// o̐l擾
int CCommonService::GetConnectionMemberInfo(HNsmConnection nConnectionID, LPCSTR lpAccount, MemberInfoType nInfoKey)
{
	TNsmInfo ni;
	TNsmMemberInfo nmi;
	int value = 0;

	memset(&nmi, 0, sizeof(nmi));
	ni.lpBuffer = (LPBYTE)&value;
	ni.nBufferSize = sizeof(value);

	nmi.cbSize = sizeof(nmi);
	nmi.lpAccount = lpAccount;
	nmi.nInfoKey = nInfoKey;
	nmi.lpInfo = &ni;
	nmi.nFlags = 0;

	CallServiceCache(ID_NMS_SYSTEM_CONNECTION_MEMBERS_GETINFO, nConnectionID, (LPARAM)&nmi);
	return value;
}

// o̐lZbg
int CCommonService::SetConnectionMemberInfo(HNsmConnection nConnectionID, LPCSTR lpAccount, MemberInfoType nInfoKey, int value)
{
	TNsmInfo ni;
	TNsmMemberInfo nmi;

	memset(&nmi, 0, sizeof(nmi));
	ni.nType = NMIT_INTEGER;
	ni.lpBuffer = (LPBYTE)&value;
//	ni.nBufferSize = sizeof(value);

	nmi.cbSize = sizeof(nmi);
	nmi.nListKind = NMLK_FORWARDLIST;
	nmi.lpAccount = lpAccount;
	nmi.nInfoKey = nInfoKey;
	nmi.lpInfo = &ni;
	nmi.nFlags = NMIF_INITLIST;

	return CallServiceCache(ID_NMS_SYSTEM_CONNECTION_MEMBERS_SETINFO, nConnectionID, (LPARAM)&nmi);
}

// o̕Zbg
int CCommonService::SetConnectionMemberInfo(HNsmConnection nConnectionID, LPCSTR lpAccount, MemberInfoType nInfoKey, LPCSTR lpStr)
{
	TNsmInfo ni;
	TNsmMemberInfo nmi;

	memset(&nmi, 0, sizeof(nmi));
	ni.nType = NMIT_STRING;
	ni.lpBuffer = (LPBYTE)lpStr;
//	ni.nBufferSize = strlen(lpStr) + 1;

	nmi.cbSize = sizeof(nmi);
	nmi.nListKind = NMLK_FORWARDLIST;
	nmi.lpAccount = lpAccount;
	nmi.nInfoKey = nInfoKey;
	nmi.lpInfo = &ni;
	nmi.nFlags = NMIF_INITLIST;

	return CallServiceCache(ID_NMS_SYSTEM_CONNECTION_MEMBERS_SETINFO, nConnectionID, (LPARAM)&nmi);
}

// o̕Zbg
int CCommonService::SetConnectionMemberInfo(HNsmConnection nConnectionID, LPCSTR lpAccount, MemberInfoType nInfoKey, LPCWSTR lpStr)
{
	TNsmInfo ni;
	TNsmMemberInfo nmi;

	memset(&nmi, 0, sizeof(nmi));
	ni.nType = NMIT_WIDESTRING;
	ni.lpBuffer = (LPBYTE)lpStr;
//	ni.nBufferSize = strlen(lpStr) + 1;

	nmi.cbSize = sizeof(nmi);
	nmi.nListKind = NMLK_FORWARDLIST;
	nmi.lpAccount = lpAccount;
	nmi.nInfoKey = nInfoKey;
	nmi.lpInfo = &ni;
	nmi.nFlags = NMIF_INITLIST;

	return CallServiceCache(ID_NMS_SYSTEM_CONNECTION_MEMBERS_SETINFO, nConnectionID, (LPARAM)&nmi);
}

// o̐lZbg
int CCommonService::SetSessionMemberInfo(HNsmSession hSession, LPCSTR lpAccount, MemberInfoType nInfoKey, int value)
{
	TNsmInfo ni;
	TNsmMemberInfo nmi;

	memset(&nmi, 0, sizeof(nmi));
	ni.nType = NMIT_INTEGER;
	ni.lpBuffer = (LPBYTE)&value;
//	ni.nBufferSize = sizeof(value);

	nmi.cbSize = sizeof(nmi);
	nmi.nListKind = NMLK_FORWARDLIST;
	nmi.lpAccount = lpAccount;
	nmi.nInfoKey = nInfoKey;
	nmi.lpInfo = &ni;
	nmi.nFlags = NMIF_INITLIST;

	return CallServiceCache(ID_NMS_SYSTEM_SESSION_MEMBERS_SETINFO, hSession, (LPARAM)&nmi);
}

// o̕Zbg
int CCommonService::SetSessionMemberInfo(HNsmSession hSession, LPCSTR lpAccount, MemberInfoType nInfoKey, LPCSTR lpStr)
{
	TNsmInfo ni;
	TNsmMemberInfo nmi;

	memset(&nmi, 0, sizeof(nmi));
	ni.nType = NMIT_STRING;
	ni.lpBuffer = (LPBYTE)lpStr;
//	ni.nBufferSize = strlen(lpStr) + 1;

	nmi.cbSize = sizeof(nmi);
	nmi.nListKind = NMLK_FORWARDLIST;
	nmi.lpAccount = lpAccount;
	nmi.nInfoKey = nInfoKey;
	nmi.lpInfo = &ni;
	nmi.nFlags = NMIF_INITLIST;

	return CallServiceCache(ID_NMS_SYSTEM_SESSION_MEMBERS_SETINFO, hSession, (LPARAM)&nmi);
}

// o̕Zbg
int CCommonService::SetSessionMemberInfo(HNsmSession hSession, LPCSTR lpAccount, MemberInfoType nInfoKey, LPCWSTR lpStr)
{
	TNsmInfo ni;
	TNsmMemberInfo nmi;

	memset(&nmi, 0, sizeof(nmi));
	ni.nType = NMIT_WIDESTRING;
	ni.lpBuffer = (LPBYTE)lpStr;
//	ni.nBufferSize = strlen(lpStr) + 1;

	nmi.cbSize = sizeof(nmi);
	nmi.nListKind = NMLK_FORWARDLIST;
	nmi.lpAccount = lpAccount;
	nmi.nInfoKey = nInfoKey;
	nmi.lpInfo = &ni;
	nmi.nFlags = NMIF_INITLIST;

	return CallServiceCache(ID_NMS_SYSTEM_SESSION_MEMBERS_SETINFO, hSession, (LPARAM)&nmi);
}

// o쐬
int CCommonService::CreateConnectionMember(HNsmConnection nConnectionID, LPCSTR lpAccount)
{
	TAddMemberInfo ami;

	memset(&ami, 0, sizeof(ami));
	ami.cbSize = sizeof(ami);
	ami.nListKind = NMLK_FORWARDLIST;
	ami.lpAccount = lpAccount;
	return CallServiceCache(ID_NMS_SYSTEM_CONNECTION_MEMBERS_ADD, nConnectionID, (LPARAM)&ami);
}

int CCommonService::CreateConnectionMember(HNsmConnection nConnectionID, int nGroupID, LPCSTR lpAccount, LPCSTR lpName, int status)
{
	TAddMemberInfo ami;
	int ret;

	memset(&ami, 0, sizeof(ami));
	ami.cbSize = sizeof(ami);
	ami.nListKind = NMLK_FORWARDLIST;
	ami.lpAccount = lpAccount;
	ret = CallServiceCache(ID_NMS_SYSTEM_CONNECTION_MEMBERS_ADD, nConnectionID, (LPARAM)&ami);
	if( ret != 0 ){
		SetConnectionMemberInfo(nConnectionID, lpAccount, NMMI_GROUPID, nGroupID);
		SetConnectionMemberInfo(nConnectionID, lpAccount, NMMI_NAME, lpName);
		SetConnectionMemberInfo(nConnectionID, lpAccount, NMMI_STATUS, status);
	}
	return ret;
}

int CCommonService::CreateConnectionMember(HNsmConnection nConnectionID, int nGroupID, LPCSTR lpAccount, LPCWSTR lpName, int status)
{
	TAddMemberInfo ami;
	int ret;

	memset(&ami, 0, sizeof(ami));
	ami.cbSize = sizeof(ami);
	ami.nListKind = NMLK_FORWARDLIST;
	ami.lpAccount = lpAccount;
	ret = CallServiceCache(ID_NMS_SYSTEM_CONNECTION_MEMBERS_ADD, nConnectionID, (LPARAM)&ami);
	if( ret != 0 ){
		SetConnectionMemberInfo(nConnectionID, lpAccount, NMMI_GROUPID, nGroupID);
		SetConnectionMemberInfo(nConnectionID, lpAccount, NMMI_NAME, lpName);
		SetConnectionMemberInfo(nConnectionID, lpAccount, NMMI_STATUS, status);
	}
	return ret;
}

// o폜
int CCommonService::DeleteConnectionMember(HNsmConnection nConnectionID, LPCSTR lpAccount)
{
	TRemoveMemberInfo rmi;
	
	memset(&rmi, 0, sizeof(rmi));
	rmi.cbSize = sizeof(rmi);
	rmi.nListKind = NMLK_FORWARDLIST;
	rmi.lpAccount = lpAccount;
	return CallServiceCache(ID_NMS_SYSTEM_CONNECTION_MEMBERS_REMOVE, nConnectionID, (LPARAM)&rmi);
}

// o擾
int CCommonService::GetConnectionMemberName(
	HNsmConnection nConnectionID, LPCSTR lpAccount,
	LPWSTR lpBuf, size_t nBufferLen
)
{
	TNsmInfo ni;
	TNsmMemberInfo nmi;
	int ret;

	memset(&nmi, 0, sizeof(nmi));
	ni.lpBuffer = (LPBYTE)lpBuf;
	ni.nBufferSize = nBufferLen;

	nmi.cbSize = sizeof(nmi);
	nmi.lpAccount = lpAccount;
	nmi.nInfoKey = NMMI_NAME;
	nmi.nListKind = NMLK_FORWARDLIST;
	nmi.lpInfo = &ni;

	ret = CallServiceCache(ID_NMS_SYSTEM_CONNECTION_MEMBERS_GETINFO, nConnectionID, (LPARAM)&nmi);
	if( ret <= 0 && nBufferLen > 0 ) lpBuf[0] = '\0';

	return ret;
}

// ZbVo擾
int CCommonService::GetSessionMemberName(HNsmSession hSessionID, LPCSTR lpAccount, LPWSTR lpBuf, size_t nBufferLen)
{
	TNsmInfo ni;
	TNsmMemberInfo nmi;
	int ret;

	memset(&nmi, 0, sizeof(nmi));
	ni.lpBuffer = (LPBYTE)lpBuf;
	ni.nBufferSize = nBufferLen;

	nmi.cbSize = sizeof(nmi);
	nmi.lpAccount = lpAccount;
	nmi.nInfoKey = NMMI_NAME;
	nmi.nListKind = NMLK_FORWARDLIST;
	nmi.lpInfo = &ni;

	ret = CallServiceCache(ID_NMS_SYSTEM_SESSION_MEMBERS_GETINFO, hSessionID, (LPARAM)&nmi);
	if( ret <= 0 && nBufferLen > 0 ) lpBuf[0] = '\0';

	return ret;
}

//*******************************************************************
// O[v
//*******************************************************************

// O[vZbg
void CCommonService::SetGroupInfo(HNsmConnection nConnectionID, int nGroupID, GroupInfoType nInfoKey, LPCWSTR lpStr)
{
	TNsmInfo ni;
	TNsmGroupInfo ngi;

	memset(&ngi, 0, sizeof(ngi));
	ni.nType = NMIT_WIDESTRING;
	ni.lpBuffer = (LPBYTE)lpStr;
	ni.nBufferSize = wcslen(lpStr) * sizeof(wchar_t) + sizeof(wchar_t);

	ngi.cbSize = sizeof(ngi);
	ngi.nGroupID = nGroupID;
	ngi.nInfoKey = nInfoKey;
	ngi.lpInfo = &ni;
	ngi.nFlags = 0;

	CallServiceCache(ID_NMS_SYSTEM_CONNECTION_GROUPS_SETINFO, nConnectionID, (LPARAM)&ngi);
}

// O[v쐬
void CCommonService::CreateGroup(HNsmConnection nConnectionID, int nGroupID, LPCWSTR pGroupName)
{
	CallServiceCache(ID_NMS_SYSTEM_CONNECTION_GROUPS_ADD, nConnectionID, nGroupID);
	SetGroupInfo(nConnectionID, nGroupID, NMGI_NAME, pGroupName);
}

void CCommonService::DeleteGroup(HNsmConnection hConnection, int nGroupID)
{
	CallServiceCache(ID_NMS_SYSTEM_CONNECTION_GROUPS_REMOVE, hConnection, nGroupID);
}

void CCommonService::ClearGroupMember(HNsmConnection hConnection, int nGroupID)
{
	member_list mlist;
	member_list::iterator mi;
	int gid;

	GetConnectionMemberList(mlist, hConnection);

	for( mi = mlist.begin(); mi != mlist.end(); ++mi ){
		gid = GetConnectionMemberInfo(hConnection, mi->c_str(), NMMI_GROUPID);
		if( gid == nGroupID )
			DeleteConnectionMember(hConnection, mi->c_str());
	}
}

// O[v擾
int CCommonService::GetGroupName(HNsmConnection ConnectionID, int nGroupID, LPWSTR lpBuf, size_t nBufferLen)
{
	TNsmGroupInfo ngi;
	TNsmInfo ni;
	int ret;

	memset(&ngi, 0, sizeof(ngi));
	ngi.cbSize = sizeof(ngi);
	ngi.nGroupID = nGroupID;
	ngi.lpInfo = &ni;
	ngi.nInfoKey = NMGI_NAME;
	ni.lpBuffer = (LPBYTE)lpBuf;
	ni.nBufferSize = nBufferLen;

	ret = CallServiceCache(ID_NMS_SYSTEM_CONNECTION_GROUPS_GETINFO, (WPARAM)ConnectionID, (LPARAM)&ngi);
	if( ret <= 0 && nBufferLen > 0 ) lpBuf[0] = '\0';

	return ret;
}

//*******************************************************************
// RlNV
//*******************************************************************

HNsmConnection CCommonService::CreateConnection(LPCSTR lpProtocol, LPCSTR lpCaption)
{
	return CallServiceCache(ID_NMS_SYSTEM_CONNECTION_CREATE, (WPARAM)lpProtocol, (LPARAM)lpCaption);
}

int CCommonService::DeleteConnection(HNsmConnection hConnection)
{
	return CallServiceCache(ID_NMS_SYSTEM_CONNECTION_DELETE, (WPARAM)hConnection, 0);
}

// intlGetConnectionInfo
int CCommonService::GetConnectionInfoInt(HNsmConnection nConnectionID, ConnectionInfoType nInfoKey)
{
	TNsmInfo ni;
	TNsmConnectionInfo nci;
	int value = 0;

	memset(&nci, 0, sizeof(nci));
	ni.nType = NMIT_INTEGER;
	ni.lpBuffer = (LPBYTE)&value;
	ni.nBufferSize = sizeof(value);

	nci.cbSize = sizeof(nci);
	nci.nInfoKey = nInfoKey;
	nci.lpInfo = &ni;

	CallServiceCache(ID_NMS_SYSTEM_CONNECTION_GETINFO, nConnectionID, (LPARAM)&nci);
	return value;
}

// intlSetConnectionInfo
int CCommonService::SetConnectionInfo(HNsmConnection nConnectionID, ConnectionInfoType nInfoKey, int value)
{
	TNsmInfo ni;
	TNsmConnectionInfo nci;

	memset(&nci, 0, sizeof(nci));
	ni.nType = NMIT_INTEGER;
	ni.lpBuffer = (LPBYTE)&value;
//	ni.nBufferSize = sizeof(value);

	nci.cbSize = sizeof(nci);
	nci.nInfoKey = nInfoKey;
	nci.lpInfo = &ni;

	return CallServiceCache(ID_NMS_SYSTEM_CONNECTION_SETINFO, nConnectionID, (LPARAM)&nci);
}

// ANSISetConnectionInfo
int CCommonService::SetConnectionInfo(HNsmConnection nConnectionID, ConnectionInfoType nInfoKey, LPCSTR str)
{
	TNsmInfo ni;
	TNsmConnectionInfo nci;

	memset(&nci, 0, sizeof(nci));
	ni.nType = NMIT_STRING;
	ni.lpBuffer = (LPBYTE)str;
//	ni.nBufferSize = strlen(str) + 1;

	nci.cbSize = sizeof(nci);
	nci.nInfoKey = nInfoKey;
	nci.lpInfo = &ni;

	return CallServiceCache(ID_NMS_SYSTEM_CONNECTION_SETINFO, nConnectionID, (LPARAM)&nci);
}

// UnicodeSetConnectionInfo
int CCommonService::SetConnectionInfo(HNsmConnection nConnectionID, ConnectionInfoType nInfoKey, LPCWSTR str)
{
	TNsmInfo ni;
	TNsmConnectionInfo nci;

	memset(&nci, 0, sizeof(nci));
	ni.nType = NMIT_WIDESTRING;
	ni.lpBuffer = (LPBYTE)str;
//	ni.nBufferSize = wcslen(str) + 1;

	nci.cbSize = sizeof(nci);
	nci.nInfoKey = nInfoKey;
	nci.lpInfo = &ni;

	return CallServiceCache(ID_NMS_SYSTEM_CONNECTION_SETINFO, nConnectionID, (LPARAM)&nci);
}

// RlNṼvgR擾
void CCommonService::GetProtocol(HNsmConnection ConnectionID, LPTSTR lpBuf, int nBufferLen)
{
	TNsmConnectionInfo nci;
	TNsmInfo ni;
	int ret;

	memset(&nci, 0, sizeof(nci));
	nci.cbSize = sizeof(nci);
	nci.nInfoKey = NMCI_PROTOCOL;
	nci.lpInfo = &ni;
	ni.lpBuffer = (LPBYTE)lpBuf;
	ni.nBufferSize = nBufferLen;

	ret = CallServiceCache(ID_NMS_SYSTEM_CONNECTION_GETINFO, (WPARAM)ConnectionID, (LPARAM)&nci);
	_ASSERT( ret <= nBufferLen );
	if( ret < 1 ) ret++;
	if( nBufferLen > 0 ) lpBuf[ret-1] = _T('\0');
}

// RlNṼ[UAJEg擾
void CCommonService::GetUserAccount(HNsmConnection ConnectionID, LPTSTR lpBuf, int nBufferLen)
{
	TNsmConnectionInfo nci;
	TNsmInfo ni;
	int ret;

	memset(&nci, 0, sizeof(nci));
	nci.cbSize = sizeof(nci);
	nci.nInfoKey = NMCI_USER_ACCOUNT;
	nci.lpInfo = &ni;
	ni.lpBuffer = (LPBYTE)lpBuf;
	ni.nBufferSize = nBufferLen;

	ret = CallServiceCache(ID_NMS_SYSTEM_CONNECTION_GETINFO, (WPARAM)ConnectionID, (LPARAM)&nci);
	_ASSERT( ret <= nBufferLen );
	if( ret < 1 ) ret++;
	if( nBufferLen > 0 ) lpBuf[ret-1] = _T('\0');
}

//*******************************************************************
// ZbV
//*******************************************************************

HNsmSession CCommonService::CreateSession(HNsmConnection hConnection)
{
	return CallServiceCache(ID_NMS_SYSTEM_SESSION_CREATE, (WPARAM)hConnection);
}

int CCommonService::DeleteSession(HNsmSession hSession)
{
	return CallServiceCache(ID_NMS_SYSTEM_SESSION_DELETE, (WPARAM)hSession);
}

int CCommonService::CreateSessionMember(HNsmSession hSession, LPCSTR lpAcc)
{
	return CallServiceCache(ID_NMS_SYSTEM_SESSION_MEMBERS_ADD, (WPARAM)hSession, (LPARAM)lpAcc);
}

int CCommonService::DeleteSessionMember(HNsmSession hSession, LPCSTR lpAcc)
{
	return CallServiceCache(ID_NMS_SYSTEM_SESSION_MEMBERS_REMOVE, (WPARAM)hSession, (LPARAM)lpAcc);
}

int CCommonService::SetSessionState(HNsmSession hSession, ConnectionStatus status)
{
	TNsmInfo ni;
	TNsmSessionInfo nsi;

	ni.nType = NMIT_INTEGER;
	ni.lpBuffer = (LPBYTE)&status;
	ni.nBufferSize = sizeof(status);

	nsi.cbSize = sizeof(nsi);
	nsi.nInfoKey = NMSI_STATUS;
	nsi.lpInfo = &ni;

	return CallServiceCache(ID_NMS_SYSTEM_SESSION_SETINFO, hSession, (LPARAM)&nsi);
}

int CCommonService::SetSessionCaption(HNsmSession hSession, LPCWSTR caption)
{
	TNsmInfo ni;
	TNsmSessionInfo nsi;

	ni.nType = NMIT_WIDESTRING;
	ni.lpBuffer = (LPBYTE)caption;
//	ni.nBufferSize = wcslen(str) + 1;

	nsi.cbSize = sizeof(nsi);
	nsi.nInfoKey = NMSI_CAPTION;
	nsi.lpInfo = &ni;

	return CallServiceCache(ID_NMS_SYSTEM_SESSION_SETINFO, hSession, (LPARAM)&nsi);
}

// ZbṼRlNV擾
HNsmConnection CCommonService::GetConnectionFromSession(HNsmSession SessionID)
{
	HNsmConnection hConnectionID;
	TNsmSessionInfo nsi;
	TNsmInfo ni;

	memset(&nsi, 0, sizeof(nsi));
	nsi.cbSize = sizeof(nsi);
	nsi.lpInfo = &ni;
	nsi.nInfoKey = NMSI_CONNECTION;
	ni.lpBuffer = (LPBYTE)&hConnectionID;
	ni.nBufferSize = sizeof(hConnectionID);

	CallServiceCache(ID_NMS_SYSTEM_SESSION_GETINFO, (WPARAM)SessionID, (LPARAM)&nsi);

	return hConnectionID;
}

void CCommonService::RecvMessage(HNsmSession hSession, PMessageInfo pmi)
{
	CallServiceCache(ID_NMS_SYSTEM_SESSION_RECEIVEMESSAGE,
		(WPARAM)hSession, (LPARAM)pmi);
}

int CCommonService::GetSessionCaption(HNsmSession hSession, LPWSTR caption, int len)
{
	TNsmSessionInfo nsi;
	TNsmInfo ni;

	nsi.cbSize = sizeof(nsi);
	nsi.lpInfo = &ni;
	nsi.nInfoKey = NMSI_CAPTION;
	ni.lpBuffer = (LPBYTE)caption;
	ni.nBufferSize = len;

	return CallServiceCache(ID_NMS_SYSTEM_SESSION_GETINFO, (WPARAM)hSession, (LPARAM)&nsi);
}

//*******************************************************************
// t@CZbV
//*******************************************************************

// t@CZbṼZbV擾
HNsmSession CCommonService::GetSessionFromFileSession(HNsmFileSession hFileSession)
{
	HNsmSession hSession;
	TNsmFileSessionInfo nfsi;
	TNsmInfo ni;

	memset(&nfsi, 0, sizeof(nfsi));
	nfsi.cbSize = sizeof(nfsi);
	nfsi.lpInfo = &ni;
	nfsi.nInfoKey = NMFI_SESSION;

	ni.lpBuffer = (LPBYTE)&hSession;
	ni.nBufferSize = sizeof(hSession);

	CallServiceCache(ID_NMS_SYSTEM_FILESESSION_GETINFO, (WPARAM)hFileSession, (LPARAM)&nfsi);

	return hSession;
}

// t@CZbṼRlNV擾
HNsmConnection CCommonService::GetConnectionFromFileSession(HNsmFileSession hFileSession)
{
	return GetConnectionFromSession(GetSessionFromFileSession(hFileSession));
}

void CCommonService::GetFileName(HNsmFileSession hFileSession, std::string &out)
{
	char buf[MAX_PATH];
	TNsmFileSessionInfo nfsi;
	TNsmInfo ni;
	int ret;

	ni.lpBuffer = (LPBYTE)buf;
	ni.nBufferSize = sizeof(buf);

	nfsi.cbSize = sizeof(nfsi);
	nfsi.nInfoKey = NMFI_FILENAME;
	nfsi.lpInfo = &ni;
	ret = CallServiceCache(ID_NMS_SYSTEM_FILESESSION_GETINFO, (WPARAM)hFileSession, (LPARAM)&nfsi);
	if( ret != 0 ) out = buf;
}

int CCommonService::GetFileSize(HNsmFileSession hFileSession)
{
	int size;
	TNsmFileSessionInfo nfsi;
	TNsmInfo ni;

	ni.lpBuffer = (LPBYTE)&size;
	ni.nBufferSize = sizeof(size);

	nfsi.cbSize = sizeof(nfsi);
	nfsi.nInfoKey = NMFI_FILESIZE;
	nfsi.lpInfo = &ni;
	CallServiceCache(ID_NMS_SYSTEM_FILESESSION_GETINFO, (WPARAM)hFileSession, (LPARAM)&nfsi);

	return size;
}

//*******************************************************************
// UI
//*******************************************************************

// bZ[W{bNX
int CCommonService::MsgBox(LPCWSTR lpTitle, LPCWSTR lpText, UINT uType/*=MB_OK*/, HWND hWnd/*=NULL*/)
{
	TMessageBoxInfo mbi;

	memset(&mbi, 0, sizeof(mbi));
	mbi.cbSize = sizeof(mbi);
	mbi.hWnd = hWnd;
	mbi.lpText = lpText;
	mbi.lpCaption = lpTitle;
	mbi.uType = uType;

	return CallServiceCache(ID_NMS_UI_MESSAGEBOX, (WPARAM)&mbi, 0);
}

// ʒm
void CCommonService::DefaultNotify(LPCSTR lpMsg,
	NotifyIconType icon/*=NMNI_EXCLAMATION*/, int ttl/*=-1*/,
	TNotifyClickCallback cback/*=NULL*/, int nData/*=NULL*/)
{
	TNotifyInfo ni;
	std::wstring wMsg;

	memset(&ni, 0, sizeof(ni));
	SJIStoUnicode(lpMsg, wMsg);

	ni.cbSize = sizeof(ni);
	ni.lpText = wMsg.c_str();
	ni.nTimeToLive = ttl;
	ni.nIcon = icon;
	ni.lpLinkTo = NULL;
	ni.lpOnClick = cback;
	ni.nData = nData;

	CallServiceCache(ID_NMS_UI_NOTIFY, (WPARAM)&ni, NULL);
}

void CCommonService::DefaultNotify(LPCWSTR lpMsg,
	NotifyIconType icon/*=NMNI_EXCLAMATION*/, int ttl/*=-1*/,
	TNotifyClickCallback cback/*=NULL*/, int nData/*=NULL*/)
{
	TNotifyInfo ni;

	ni.cbSize = sizeof(ni);
	ni.lpText = lpMsg;
	ni.nTimeToLive = ttl;
	ni.nIcon = icon;
	ni.lpLinkTo = NULL;
	ni.lpOnClick = cback;
	ni.nData = nData;

	CallServiceCache(ID_NMS_UI_NOTIFY, (WPARAM)&ni, NULL);
}

//*******************************************************************
// vgR
//*******************************************************************

// [U[Xe[^XύX
void CCommonService::ChangeUserStatus(LPTSTR protocol, HNsmConnection hConnectionID, MemberStatus nState)
{
	TUserStatusInfo usi;
	size_t len;
	LPSTR serviceName;

	memset(&usi, 0, sizeof(usi));
	usi.cbSize = sizeof(usi);
	usi.nStatus = nState;

	len = strlen(NMS_PROTOCOL_CONNECTION_CHANGEUSERSTATUS);
	len += strlen(protocol);
	serviceName = new char[len];
	sprintf_s(serviceName, len, NMS_PROTOCOL_CONNECTION_CHANGEUSERSTATUS, protocol);

	CallService(serviceName, hConnectionID, (LPARAM)&usi);
	delete serviceName;
}

// [U[ύX
void CCommonService::ChangeUserName(LPTSTR protocol, HNsmConnection hConnectionID, LPCWSTR name)
{
	TUserNameInfo uni;
	int len;
	LPSTR serviceName;

	memset(&uni, 0, sizeof(uni));
	uni.cbSize = sizeof(uni);
	uni.lpName = name;

	len = strlen(NMS_PROTOCOL_CONNECTION_CHANGEUSERNAME);
	len += strlen(protocol);
	serviceName = new char[len];
	sprintf_s(serviceName, len, NMS_PROTOCOL_CONNECTION_CHANGEUSERNAME, protocol);

	CallService(serviceName, hConnectionID, (LPARAM)&uni);
	delete serviceName;
}

//*******************************************************************
// Enum
//*******************************************************************

int CCommonService::GetProtocolList(protocol_list &list)
{
	TEnumProtocolCallback func = AddEnumItems<LPCTSTR, std::string>;
	return CallServiceCache(ID_NMS_SYSTEM_ENUMPROTOCOLS, (WPARAM)func, (LPARAM)&list);
}

int CCommonService::GetModuleList(module_list &list)
{
	TEnumModuleCallback func = AddEnumItems<LPCTSTR, std::string>;
	return CallServiceCache(ID_NMS_SYSTEM_ENUMMODULES, (WPARAM)func, (LPARAM)&list);
}

int CCommonService::GetConnectionList(connection_list &list)
{
	TEnumConnectionCallback func = AddEnumItems<HNsmConnection>;
	return CallServiceCache(ID_NMS_SYSTEM_CONNECTION_ENUM, (WPARAM)func, (LPARAM)&list);
}

int CCommonService::GetConnectionMemberList(member_list &list, HNsmConnection hConnection, int nListKind)
{
	TEnumMemberInfo emi;

	memset(&emi, 0, sizeof(emi));
	emi.cbSize = sizeof(emi);
	emi.lpCallBackProc = AddEnumItems<LPCTSTR, std::string>;
	emi.nData = (int)&list;
	emi.nListKind = nListKind;

	return CallServiceCache(ID_NMS_SYSTEM_CONNECTION_MEMBERS_ENUM, hConnection, (LPARAM)&emi);
}

int CCommonService::GetConnectionGroupList(group_list &list, HNsmConnection hConnection)
{
	TEnumGroupInfo egi;

	memset(&egi, 0, sizeof(egi));
	egi.cbSize = sizeof(egi);
	egi.lpCallBackProc = AddEnumItems<int>;
	egi.nData = (int)&list;

	return CallServiceCache(ID_NMS_SYSTEM_CONNECTION_GROUPS_ENUM, hConnection, (LPARAM)&egi);
}

int CCommonService::GetSessionList(session_list &list)
{
	TEnumSessionCallback func = AddEnumItems<HNsmSession>;
	return CallServiceCache(ID_NMS_SYSTEM_SESSION_ENUM, (WPARAM)func, (LPARAM)&list);
}

int CCommonService::GetSessionMemberList(member_list &list, HNsmSession hSession, int nListKind)
{
	TEnumMemberInfo emi;

	memset(&emi, 0, sizeof(emi));
	emi.cbSize = sizeof(emi);
	emi.lpCallBackProc = AddEnumItems<LPCTSTR, std::string>;
	emi.nData = (int)&list;
	emi.nListKind = nListKind;

	return CallServiceCache(ID_NMS_SYSTEM_SESSION_MEMBERS_ENUM, hSession, (LPARAM)&emi);
}

int CCommonService::GetUIServiceList(uiservice_list &list, HNsmConnection hConnection, LPCTSTR lpServiceName)
{
	TEnumUIServiceInfo euisi;

	memset(&euisi, 0, sizeof(euisi));
	euisi.cbSize = sizeof(euisi);
	euisi.lpCallBackProc = AddEnumItems<LPCTSTR, std::string>;
	euisi.nData = (int)&list;

	return CallService(lpServiceName, hConnection, (LPARAM)&euisi);
}

int CCommonService::GetConnectionMemberUISList(uiservice_list &list, HNsmConnection hConnection)
{
	return GetUIServiceList(list, hConnection, NMS_SYSTEM_CONNECTION_UISERVICE_MEMBER_ENUM);
}

int CCommonService::GetConnectionGroupUISList(uiservice_list &list, HNsmConnection hConnection)
{
	return GetUIServiceList(list, hConnection, NMS_SYSTEM_CONNECTION_UISERVICE_GROUP_ENUM);
}

int CCommonService::GetAddinMainUISList(uiservice_list &list, HNsmConnection hConnection)
{
	return GetUIServiceList(list, hConnection, NMS_SYSTEM_ADDIN_UISERVICE_MAIN_ENUM);
}

int CCommonService::GetAddinMemberUISList(uiservice_list &list, HNsmConnection hConnection)
{
	return GetUIServiceList(list, hConnection, NMS_SYSTEM_ADDIN_UISERVICE_MEMBER_ENUM);
}

int CCommonService::GetAddinGroupUISList(uiservice_list &list, HNsmConnection hConnection)
{
	return GetUIServiceList(list, hConnection, NMS_SYSTEM_ADDIN_UISERVICE_GROUP_ENUM);
}

int CCommonService::GetAddinTabUISList(uiservice_list &list, HNsmConnection hConnection)
{
	return GetUIServiceList(list, hConnection, NMS_SYSTEM_ADDIN_UISERVICE_TAB_ENUM);
}

// EnumItem == LPCTSTR ̎ System W[̎ɂĂ
// list ׂ̂Ă̒lɂȂ\B
template <class EnumItemT>
static int __stdcall CCommonService::AddEnumItems(EnumItemT item, int nData)
{
	return AddEnumItems<EnumItemT, EnumItemT>(item, nData);
}

template <class EnumItemT, class ListItemT>
static int __stdcall CCommonService::AddEnumItems(EnumItemT item, int nData)
{
	CNsmEnumList<ListItemT> &list = *(CNsmEnumList<ListItemT>*)nData;

	list.push_back(item);
	return NMP_ALLRIGHT;
}

//*******************************************************************
// ̑
//*******************************************************************

int CCommonService::GetPluginInfo(LPCTSTR lpModuleName, PluginInfoType nInfoNo, LPTSTR lpBuf, int len)
{
	TNsmPluginInfo npi;
	int ret;

	memset(&npi, 0, sizeof(npi));
	npi.cbSize = sizeof(npi);
	npi.lpModuleName = lpModuleName;
	npi.nInfoNo = nInfoNo;
	npi.lpBuffer = lpBuf;
	npi.nBufferSize = len;

	ret = CallServiceCache(ID_NMS_SYSTEM_GETPLUGININFO, (WPARAM)&npi, 0);
	if( ret <= 0 && len > 0 ) lpBuf[0] = '\0';

	return ret;
}

int CCommonService::NsmInfoToUnicode(TNsmInfo &ni, std::wstring &out)
{
	switch( ni.nType ){
	case NMIT_STRING:
		::SJIStoUnicode((LPCSTR)ni.lpBuffer, out);
		break;
	case NMIT_WIDESTRING:
		out = (LPCWSTR)ni.lpBuffer;
		break;
	default:
		return FALSE;
	}

	return TRUE;
}

