#pragma once
#pragma warning( disable: 4702 )
	#include <vector>
#pragma warning( default: 4702 )
#include <string>
#include "nsmsgs.h"
#include "debug.h"

#define BUF_SIZE		256
#define NSM_SERVICE	(CCommonService::GetInstance())

enum{
	ID_NMS_SYSTEM_EXIT,
	ID_NMS_SYSTEM_DEBUG_PRINT,
	ID_NMS_SYSTEM_ENUMPROTOCOLS,
	ID_NMS_SYSTEM_ENUMMODULES,
	ID_NMS_SYSTEM_GETPLUGININFO,
	ID_NMS_SYSTEM_CONNECTION_CREATE,
	ID_NMS_SYSTEM_CONNECTION_DELETE,
	ID_NMS_SYSTEM_CONNECTION_GETINFO,
	ID_NMS_SYSTEM_CONNECTION_SETINFO,
	ID_NMS_SYSTEM_CONNECTION_ENUM,
	ID_NMS_SYSTEM_CONNECTION_MEMBERS_ADD,
	ID_NMS_SYSTEM_CONNECTION_MEMBERS_REMOVE,
	ID_NMS_SYSTEM_CONNECTION_MEMBERS_GETINFO,
	ID_NMS_SYSTEM_CONNECTION_MEMBERS_SETINFO,
	ID_NMS_SYSTEM_CONNECTION_MEMBERS_ENUM,
	ID_NMS_SYSTEM_CONNECTION_MEMBERS_BEGINUPDATE,
	ID_NMS_SYSTEM_CONNECTION_MEMBERS_ENDUPDATE,
	ID_NMS_SYSTEM_CONNECTION_GROUPS_ADD,
	ID_NMS_SYSTEM_CONNECTION_GROUPS_REMOVE,
	ID_NMS_SYSTEM_CONNECTION_GROUPS_GETINFO,
	ID_NMS_SYSTEM_CONNECTION_GROUPS_SETINFO,
	ID_NMS_SYSTEM_CONNECTION_GROUPS_ENUM,
	ID_NMS_SYSTEM_CONNECTION_GROUPS_BEGINUPDATE,
	ID_NMS_SYSTEM_CONNECTION_GROUPS_ENDUPDATE,
	ID_NMS_SYSTEM_SESSION_CREATE,
	ID_NMS_SYSTEM_SESSION_DELETE,
	ID_NMS_SYSTEM_SESSION_GETINFO,
	ID_NMS_SYSTEM_SESSION_SETINFO,
	ID_NMS_SYSTEM_SESSION_ENUM,
	ID_NMS_SYSTEM_SESSION_MEMBERS_ADD,
	ID_NMS_SYSTEM_SESSION_MEMBERS_REMOVE,
	ID_NMS_SYSTEM_SESSION_MEMBERS_GETINFO,
	ID_NMS_SYSTEM_SESSION_MEMBERS_SETINFO,
	ID_NMS_SYSTEM_SESSION_MEMBERS_ENUM,
	ID_NMS_SYSTEM_SESSION_MEMBERS_BEGINUPDATE,
	ID_NMS_SYSTEM_SESSION_MEMBERS_ENDUPDATE,
	ID_NMS_SYSTEM_SESSION_SENDMESSAGE,
	ID_NMS_SYSTEM_SESSION_RECEIVEMESSAGE,
	ID_NMS_SYSTEM_FILESESSION_CREATE,
	ID_NMS_SYSTEM_FILESESSION_DELETE,
	ID_NMS_SYSTEM_FILESESSION_GETINFO,
	ID_NMS_SYSTEM_FILESESSION_SETINFO,
	ID_NMS_SYSTEM_FILESESSION_ENUM,
//	ID_NMS_SYSTEM_CONNECTION_UISERVICE_MEMBER_ENUM,
//	ID_NMS_SYSTEM_CONNECTION_UISERVICE_GROUP_ENUM,
//	ID_NMS_SYSTEM_ADDIN_UISERVICE_MAIN_ENUM,
//	ID_NMS_SYSTEM_ADDIN_UISERVICE_MEMBER_ENUM,
//	ID_NMS_SYSTEM_ADDIN_UISERVICE_GROUP_ENUM,
//	ID_NMS_SYSTEM_ADDIN_UISERVICE_TAB_ENUM,
	ID_NMS_UI_MESSAGEBOX,
	ID_NMS_UI_NOTIFY,
	NUM_OF_SERVICE_CACHE
};

class CCommonService
{
private:
	const static LPCSTR SYSTEM_MSG[NUM_OF_SERVICE_CACHE];

public:
	#define CNsmEnumList std::vector
	typedef CNsmEnumList<HNsmConnection> connection_list;
	typedef CNsmEnumList<HNsmSession> session_list;
	typedef CNsmEnumList<HNsmFileSession> filesession_list;
	typedef CNsmEnumList<std::string> protocol_list;
	typedef CNsmEnumList<std::string> module_list;
	typedef CNsmEnumList<std::string> member_list;
	typedef CNsmEnumList<int> group_list;
	typedef CNsmEnumList<std::string> uiservice_list;

// singleton -->
private:
	static CCommonService m_singleton;

private:
	CCommonService();
	~CCommonService(void);

public:
	static CCommonService& GetInstance()
	{
		return m_singleton;
	}
// <-- singleton

private:
	HNsmService m_serviceCache[NUM_OF_SERVICE_CACHE];
	TNsmPluginInitInfo m_InitInfo;
	bool m_bValid;

	PNsmPluginInitInfo InitInfo(void)
	{
		return &m_InitInfo;
	}

public:
	void SetInitInfo(TNsmPluginInitInfo *info)
	{
		m_InitInfo = *info;
		m_bValid = true;
	}
	void Terminate()
	{
		m_bValid = false;
	}

private:
	int CallService(int no, LPCTSTR msgname, WPARAM wParam, LPARAM lParam);

public:
	DEBUG_CODE(
		HNsmService md_hLog;
		void DebugLog(LPCSTR /*msgname*/)
		{
//			if( md_hLog == NULL ) md_hLog = GetService("Addin/Logger/DebugLog");
//			CallService(md_hLog, (WPARAM)msgname);
		}
	);

public:
// {
	HNsmService CreateService(LPCTSTR ServiceName, TNsmServiceProc ProcAddr);
	HNsmService GetService(LPCTSTR ServiceName);
	int CallService(HNsmService ServiceHandle, WPARAM wParam=0, LPARAM lParam=0);
	HNsmEvent CreateEvent(LPCTSTR EventName);
	HNsmEvent GetEvent(LPCTSTR EventName);
	int NotifyEvent(HNsmEvent EventHandle, WPARAM wParam=0, LPARAM lParam=0);
	int HookEvent(LPCTSTR EventName, TNsmEventProc ProcAddr);
	int UnhookEvent(LPCTSTR EventName, TNsmEventProc ProcAddr);

// g
	int CallService(LPCTSTR msgname, WPARAM wParam=0, LPARAM lParam=0);
	int CallServiceCache(int service_id, WPARAM wParam=0, LPARAM lParam=0)
	{
		DEBUG_CODE( DebugLog(SYSTEM_MSG[service_id]) );
		return (m_serviceCache[service_id] == NULL) ?
			CallService(service_id, SYSTEM_MSG[service_id], wParam, lParam):
			CallService(m_serviceCache[service_id], wParam, lParam);
	}

// [U[
	int GetUserName(HNsmConnection ConnectionID, LPWSTR lpBuf, size_t nBufferLen);
	void SetUserName(HNsmConnection hConnectionID, LPCWSTR lpUserName);
	int GetUserStatus(HNsmConnection hConnectionID);
	void SetUserStatus(HNsmConnection hConnectionID, int nUserStatus);

// o
	void DeleteAllConnectionMembers(HNsmConnection hConnection);
	void ConnectionMemberBeginUpdate(HNsmConnection hConnection);
	void ConnectionMemberEndUpdate(HNsmConnection hConnection);
	int GetConnectionMemberInfo(HNsmConnection nConnectionID, LPCSTR lpAccount, MemberInfoType nInfoKey);
	int SetConnectionMemberInfo(HNsmConnection nConnectionID, LPCSTR lpAccount, MemberInfoType nInfoKey, int value);
	int SetConnectionMemberInfo(HNsmConnection nConnectionID, LPCSTR lpAccount, MemberInfoType nInfoKey, LPCSTR lpStr);
	int SetConnectionMemberInfo(HNsmConnection nConnectionID, LPCSTR lpAccount, MemberInfoType nInfoKey, LPCWSTR lpStr);
	int CreateConnectionMember(HNsmConnection nConnectionID, LPCSTR lpAccount);
	int CreateConnectionMember(HNsmConnection nConnectionID, int nGroupID, LPCSTR lpAccount, LPCSTR lpName, int status);
	int CreateConnectionMember(HNsmConnection nConnectionID, int nGroupID, LPCSTR lpAccount, LPCWSTR lpName, int status);
	int DeleteConnectionMember(HNsmConnection nConnectionID, LPCSTR lpAccount);
	int GetConnectionMemberName(HNsmConnection nConnectionID, LPCSTR lpAccount, LPWSTR lpBuf, size_t nBufferLen);
	int GetSessionMemberName(HNsmSession hSessionID, LPCSTR lpAccount, LPWSTR lpBuf, size_t nBufferLen);

	int SetSessionMemberInfo(HNsmSession hSession, LPCSTR lpAccount, MemberInfoType nInfoKey, int value);
	int SetSessionMemberInfo(HNsmSession hSession, LPCSTR lpAccount, MemberInfoType nInfoKey, LPCSTR lpStr);
	int SetSessionMemberInfo(HNsmSession hSession, LPCSTR lpAccount, MemberInfoType nInfoKey, LPCWSTR lpStr);


// O[v
	void CreateGroup(HNsmConnection nConnectionID, int nGroupID, LPCWSTR pGroupName);
	void DeleteGroup(HNsmConnection hConnection, int nGroupID);
	void ClearGroupMember(HNsmConnection hConnection, int nGroupID);
	void SetGroupInfo(HNsmConnection nConnectionID, int nGroupID, GroupInfoType nInfoKey, LPCWSTR lpStr);
	int GetGroupName(HNsmConnection ConnectionID, int nGroupID, LPWSTR lpBuf, size_t nBufferLen);

// RlNV
	HNsmConnection CreateConnection(LPCSTR lpProtocol, LPCSTR lpCaption);
	int DeleteConnection(HNsmConnection hConnection);
	int GetConnectionInfoInt(HNsmConnection nConnectionID, ConnectionInfoType nInfoKey);
	int SetConnectionInfo(HNsmConnection nConnectionID, ConnectionInfoType nInfoKey, int value);
	int SetConnectionInfo(HNsmConnection nConnectionID, ConnectionInfoType nInfoKey, LPCSTR str);
	int SetConnectionInfo(HNsmConnection nConnectionID, ConnectionInfoType nInfoKey, LPCWSTR str);
	// RlNṼvgR擾
	void GetProtocol(HNsmConnection ConnectionID, LPTSTR lpBuf, int nBufferLen);
	// RlNṼ[UAJEg擾
	void GetUserAccount(HNsmConnection ConnectionID, LPTSTR lpBuf, int nBufferLen);

// ZbV
	HNsmSession CreateSession(HNsmConnection hConnection);
	int DeleteSession(HNsmSession hSession);
	int CreateSessionMember(HNsmSession hSession, LPCSTR lpAcc);
	int DeleteSessionMember(HNsmSession hSession, LPCSTR lpAcc);
	int SetSessionState(HNsmSession hSession, ConnectionStatus status);
	int SetSessionCaption(HNsmSession hSession, LPCWSTR caption);
	int GetSessionCaption(HNsmSession hSession, LPWSTR caption, int len);
	void RecvMessage(HNsmSession hSession, PMessageInfo pmi);
	// ZbṼRlNV擾
	HNsmConnection GetConnectionFromSession(HNsmSession SessionID);

// t@CZbV
	HNsmConnection GetConnectionFromFileSession(HNsmFileSession hFileSession);
	HNsmSession GetSessionFromFileSession(HNsmFileSession hFileSession);
	void GetFileName(HNsmFileSession hFileSession, std::string &out);
	int GetFileSize(HNsmFileSession hFileSession);

// UI
	int MsgBox(LPCWSTR lpTitle, LPCWSTR lpText, UINT uType=MB_OK, HWND hWnd=NULL);
//	void DefaultNotify(LPCTSTR lpMsg, NotifyIconType icon=NMNI_EXCLAMATION, int time=-1);
	void DefaultNotify(LPCSTR lpMsg, NotifyIconType icon=NMNI_EXCLAMATION,
		int time=-1, TNotifyClickCallback cback=NULL, int nData=NULL);
	void DefaultNotify(LPCWSTR lpMsg, NotifyIconType icon=NMNI_EXCLAMATION,
		int time=-1, TNotifyClickCallback cback=NULL, int nData=NULL);

// vgR
	void ChangeUserStatus(LPTSTR protocol, HNsmConnection hConnectionID, MemberStatus nState);
	void ChangeUserName(LPTSTR protocol, HNsmConnection hConnectionID, LPCWSTR name);

// Enum
	int GetProtocolList(protocol_list &list);
	int GetModuleList(module_list &list);
	int GetConnectionList(connection_list &list);
	int GetConnectionMemberList(member_list &list, HNsmConnection hConnection, int nListKind = NMLK_FORWARDLIST);
	int GetConnectionGroupList(group_list &list, HNsmConnection hConnection);
	int GetSessionList(session_list &list);
	int GetSessionMemberList(member_list &list, HNsmSession hSession, int nListKind = NMLK_FORWARDLIST);
	int GetUIServiceList(uiservice_list &list, HNsmConnection hConnection, LPCTSTR lpServiceName);
	int GetConnectionMemberUISList(uiservice_list &list, HNsmConnection hConnection);
	int GetConnectionGroupUISList(uiservice_list &list, HNsmConnection hConnection);
	int GetAddinMainUISList(uiservice_list &list, HNsmConnection hConnection);
	int GetAddinMemberUISList(uiservice_list &list, HNsmConnection hConnection);
	int GetAddinGroupUISList(uiservice_list &list, HNsmConnection hConnection);
	int GetAddinTabUISList(uiservice_list &list, HNsmConnection hConnection);
	template <class EnumItemT>
		static int __stdcall AddEnumItems(EnumItemT item, int nData);
	template <class EnumItemT, class ListItemT>
		static int __stdcall AddEnumItems(EnumItemT item, int nData);

// ̑
	int GetPluginInfo(LPCTSTR lpModuleName, PluginInfoType nInfoNo, LPTSTR lpBuf, int len);
	int NsmInfoToUnicode(TNsmInfo &ni, std::wstring &out);
};
