#include "StdAfx.h"
#include "dlg.h"
#include "mleak.h"
#pragma comment(lib, "comctl32.lib")

#ifdef  __cplusplus
extern "C" {
#endif
	void *          __cdecl _alloca(size_t);
#ifdef  __cplusplus
}
#endif

//*******************************************************************
// RXgN^EfXgN^
//*******************************************************************
CDlg::CDlg(UINT nIDTemplate/*=0*/, UINT nIDAccelerator/*=0*/)
: m_nIDTemplate(nIDTemplate)
, m_nIDAccelerator(nIDAccelerator)
{
	m_hInstance = NULL;
	m_bModal = false;
	m_bAccel = false;
}

CDlg::~CDlg(void)
{
}

//*******************************************************************
// _CAO
//*******************************************************************

// [__CAOI[v
//  hWnd: eEChẼEChEnh
INT_PTR CDlg::DoModal(HINSTANCE hInstance, HWND hWnd)
{
	::InitCommonControls();
	_ASSERT( m_nIDTemplate != 0 );
	m_bModal = true;
	m_hInstance = hInstance;
	return ::DialogBoxParam(hInstance, MAKEINTRESOURCE(m_nIDTemplate),
		hWnd, DlgProc, (LPARAM)this);
}

// [hX_CAOI[v
//  hWnd: eEChẼEChEnh
HWND CDlg::Create(HINSTANCE hInstance, HWND hWnd)
{
	::InitCommonControls();
	_ASSERT( m_nIDTemplate != 0 );
	m_bModal = false;
	m_hInstance = hInstance;
	return ::CreateDialogParam(hInstance, MAKEINTRESOURCE(m_nIDTemplate),
		hWnd, DlgProc, (LPARAM)this);
}

// ANZ[^tU[__CAOI[v
//  hWnd: eEChẼEChEnh
INT_PTR CDlg::DoModalWithAccelerator(HINSTANCE hInstance, HWND hWnd)
{
	MSG msg;
	HACCEL hAccel = NULL;
	HWND hDlg;

	m_bAccel = true;
	m_hInstance = hInstance;
	hDlg = Create(hInstance, hWnd);
	if( m_nIDAccelerator != 0 ){
		hAccel = ::LoadAccelerators(hInstance, MAKEINTRESOURCE(m_nIDAccelerator));
	}

	while ( ::GetMessage(&msg, NULL, 0, 0) > 0 )
    {
		if( hAccel != NULL )
			if( ::TranslateAccelerator(hDlg, hAccel, &msg) )
				continue;

		if( ::IsDialogMessage(hDlg, &msg) ) continue;

		::TranslateMessage(&msg);
        ::DispatchMessage(&msg);
    }

	return msg.wParam;
}


// _CAOCX^XɊ֘At
//  hWnd: _CAÕEChEnh
BOOL CDlg::Attach(HWND hWnd)
{
	m_hDlgWnd = hWnd;
	return InitDlgCtrl();
}

BOOL CDlg::DlgProc(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/)
{
	return FALSE;
}

// _CAORg[
BOOL CDlg::InitDlgCtrl()
{
	return TRUE;
}

// _CAORg[̒l擾
BOOL CDlg::GetDlgCtrlValue()
{
	return TRUE;
}

void CDlg::ExitDialog(INT_PTR nExitCode)
{
	if( m_bModal ){
		::EndDialog(m_hDlgWnd, nExitCode);
	}else{
		if( m_bAccel ) m_ret = nExitCode;
		::DestroyWindow(m_hDlgWnd);
	}
}

//*******************************************************************
// Rg[
//*******************************************************************
// GfBbg{bNXeLXg擾
//  hWnd: GfBbg{bNX̃EChEnh
//  ߂l: GfBbg{bNX̃eLXgi[V擾obt@ւ̃|C^
void CDlg::GetItemText(HWND hItem, std::string &text) const
{
	LPTSTR newStr;
	int len;

	len = ::GetWindowTextLength(hItem) + 1;
	newStr = (LPTSTR)_alloca(len);
	::GetWindowText(hItem, newStr, len);

	text = newStr;
}

int CDlg::GetItemTextInt(HWND hItem) const
{
	LPTSTR str;
	int len;

	len = ::GetWindowTextLength(hItem) + 1;
	str = (LPTSTR)_alloca(len);
	::GetWindowText(hItem, str, len);
	return atoi(str);
}

void CDlg::SetCombo(int nID, const StringList &strs, int iSelect) const
{
	HWND hWnd = GetDlgItem(nID);
	StringList::const_iterator str;

	for( str = strs.begin(); str != strs.end(); ++str ){
		::SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)str->c_str());
	}

	::SendMessage(hWnd, CB_SETCURSEL, iSelect, 0);
}

void CDlg::SetCombo(int nID, LPCSTR const strs[], int nNumStrs, int iSelect) const
{
	HWND hWnd = GetDlgItem(nID);

	for( int i = 0; i < nNumStrs; ++i )
		::SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)strs[i]);

	::SendMessage(hWnd, CB_SETCURSEL, iSelect, 0);
}

//*******************************************************************
// _CAOvV[W
//*******************************************************************
BOOL CALLBACK CDlg::DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	if( uMsg == WM_INITDIALOG )
	{
		// SetProp(hWnd, "RegneDlg", lParam);
		::SetWindowLongPtr(hWnd, GWL_USERDATA, static_cast<LONG_PTR>(lParam));
		return ((CDlg*)lParam)->Attach(hWnd);
	}
	else
	{
		CDlg* pDlg = reinterpret_cast<CDlg*>(static_cast<LONG_PTR>(::GetWindowLongPtr(hWnd, GWL_USERDATA)));

		if( pDlg == NULL ) return FALSE;

		if( uMsg == WM_COMMAND ){
			// OK{^
			if( LOWORD(wParam) == IDOK )
			{
				if( pDlg->GetDlgCtrlValue() ){
					pDlg->ExitDialog(IDOK);
				}
				return TRUE;
			}
			// LZ{^
			else if( LOWORD(wParam) == IDCANCEL )
			{
				pDlg->ExitDialog(IDCANCEL);
				return TRUE;
			}
		}else if( uMsg == WM_DESTROY ){
			if( pDlg->m_bAccel )
			{
				::PostQuitMessage(static_cast<int>(pDlg->m_ret));
			}
			::SetWindowLongPtr(hWnd, GWL_USERDATA, NULL);
		}

		// ̑
		return pDlg->DlgProc(uMsg, wParam, lParam);
	}
}
