#pragma once
#include <commctrl.h>
#pragma warning( disable: 4702 )
	#include <vector>
#pragma warning( default: 4702 )
#include "tstring.h"
#include "StringList.h"
#include "ToolTip.h"

#define HANDLE_CMD(cmdid, fn) \
	case (cmdid): (fn); break

class CDlg
{
public:
	// RXgN^EfXgN^
	CDlg(UINT nIDTemplate=0, UINT nIDAccelerator=0);
	CDlg& operator =(const CDlg &/*other*/)
	{ _ASSERT(FALSE); }
	virtual ~CDlg(void);

	INT_PTR DoModal(HINSTANCE hInstance, HWND hWnd);
	INT_PTR DoModalWithAccelerator(HINSTANCE hInstance, HWND hWnd);
	HWND Create(HINSTANCE hInstance, HWND hWnd);
	BOOL Attach(HWND hWnd);

protected:
	void ExitDialog(INT_PTR nExitCode);

protected:
	HINSTANCE m_hInstance;
	HWND m_hDlgWnd;
	const UINT m_nIDTemplate;
	const UINT m_nIDAccelerator;
	bool m_bModal;
	bool m_bAccel;
	INT_PTR m_ret;
//	HWND m_hTipWnd;

// Rg[
protected:
	void GetItemText(HWND hItem, std::string &text) const;
	int GetItemTextInt(HWND hItem) const;
	void SetCombo(int nID, const StringList &strs, int iSelect) const;
	void SetCombo(int nID, LPCSTR const strs[], int nNumStrs, int iSelect) const;

	void GetItemText(int nID, std::string &text) const
	{ GetItemText(GetDlgItem(nID), text); }
	int GetItemTextInt(int nID) const
	{ return GetItemTextInt(GetDlgItem(nID)); }
	bool SetEnable(int nID, BOOL bEnable) const
	{ return EnableWindow(GetDlgItem(nID), bEnable) != FALSE; }
	BOOL SetVisible(int nID, bool bVisible) const
	{ return ::ShowWindow(GetDlgItem(nID), bVisible ? SW_SHOW: SW_HIDE); }

	void SetCheck(int nID, BOOL bState) const
	{
		::SendMessage(GetDlgItem(nID), BM_SETCHECK,
			(WPARAM)(bState ? BST_CHECKED: BST_UNCHECKED), NULL);
	}
	bool GetCheck(int nID) const
	{
		return BST_CHECKED == ::SendMessage(GetDlgItem(nID),
									BM_GETCHECK, NULL, NULL);
	}
	void SetItemText(int nID, LPCSTR str) const
	{ ::SetWindowText(GetDlgItem(nID), str); }
	void SetItemText(int nID, int n) const
	{
		char buf[32];
		_itoa_s(n, buf, 10);
		::SetWindowText(GetDlgItem(nID), buf);
	}
	HWND GetDlgItem(int nID) const
	{ return ::GetDlgItem(m_hDlgWnd, nID); }
	LRESULT SendMessage(int nID, UINT msg, WPARAM wParam=0, LPARAM lParam=0) const
	{ return ::SendMessage(GetDlgItem(nID), msg, wParam, lParam); }
	int GetComboCurSel(int nID, int def)
	{
		LRESULT ret = SendMessage(nID, CB_GETCURSEL);
		return (ret == CB_ERR) ? def: ret;
	}

// I[o[Ch]
protected:
	// _CAOvV[W
	virtual BOOL DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
	virtual BOOL InitDlgCtrl();
	virtual BOOL GetDlgCtrlValue();

// _CAOvV[W
private:
	static BOOL CALLBACK DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
};
