#pragma once
#include "debug.h"

template <class T>
class DynamicArray
{
private:
	T *array;
	DEBUG_CODE(unsigned int dbg_size);

public:
	DynamicArray(int size)
	{
		_ASSERT( 0 < size );
		DEBUG_CODE(dbg_size = size);
		array = new T[size];
	}
	DynamicArray(size_t size)
	{
		_ASSERT( 0 < size );
		DEBUG_CODE(dbg_size = size);
		array = new T[size];
	}
	~DynamicArray()
	{
		delete array;
	}
	T& operator [](int i)
	{
		_ASSERT( 0 <= i && (unsigned int)i < dbg_size );
		return array[i];
	}
	T& operator [](unsigned int i)
	{
		_ASSERT( i < dbg_size );
		return array[i];
	}
	operator T*()
	{
		return array;
	}
};
