#pragma once

class CEventHandle
{
protected:
	bool m_bOwner;
	HANDLE m_hEvent;

public:
	CEventHandle(bool bManualReset=FALSE, bool bInitialState=FALSE, LPCTSTR name=NULL)
		: m_hEvent(::CreateEvent(NULL, bManualReset, bInitialState, name))
		, m_bOwner(true)
	{
		if( m_hEvent == INVALID_HANDLE_VALUE )
		{
			throw 0;
		}
	}
	explicit CEventHandle(HANDLE right)
		: m_hEvent(right)
	{
	}
	CEventHandle(const CEventHandle& right)
		: m_hEvent(right.m_hEvent)
		, m_bOwner(false)
	{
	}

	~CEventHandle(void)
	{
		if( m_bOwner )
		{
			::CloseHandle(m_hEvent);
		}
	}

	void Set()
	{
		::SetEvent(m_hEvent);
	}
	void Reset()
	{
		::ResetEvent(m_hEvent);
	}
	DWORD Wait(DWORD dwMiliseconds=INFINITE) const
	{
		return ::WaitForSingleObject(m_hEvent, dwMiliseconds);
	}
	DWORD IsSet() const
	{
		DWORD ret = Wait(0);
		if( ret == WAIT_FAILED ) throw 0;
		return ret == WAIT_OBJECT_0;
	}
	operator HANDLE() const
	{
		return m_hEvent;
	}
};
