#pragma once
#pragma warning( disable: 4702 )
	#include <map>
	#include <vector>
#pragma warning( default: 4702 )
#include "tstring.h"

class CIniFile
{
public:
	enum{ INI_BUF_SIZE=256 };
	typedef std::map<tstring, tstring> EntryList;
	typedef std::vector<tstring> SectionList;

protected:
	tstring m_iniFilePath;

public:
	CIniFile(void);
	~CIniFile(void);
	void SetIniFileName(LPCTSTR filename);
	void SetIniFileNameDefault();
	bool ReadBool(LPCTSTR section, LPCTSTR entry, bool bDefault);
	int ReadInt(LPCTSTR section, LPCTSTR entry, int nDefault);
	void ReadString(tstring &out, LPCTSTR section, LPCTSTR entry, LPCTSTR defaultString);
	void Read(LPCTSTR section, LPCTSTR entry, LPVOID pStruct, UINT size)
	{ ::GetPrivateProfileStruct(section, entry, pStruct, size, m_iniFilePath.c_str()); }
	void ReadSection(LPCSTR section, EntryList &list);
	void GetSectionList(SectionList &list);
	void Write(LPCTSTR section, LPCTSTR entry, int value);
	void Write(LPCTSTR section, LPCTSTR entry, LPCTSTR str);
	void Write(LPCTSTR section, LPCTSTR entry, LPVOID pStruct, UINT size)
	{ ::WritePrivateProfileStruct(section, entry, pStruct, size, m_iniFilePath.c_str()); }
	void Delete(LPCTSTR section, LPCTSTR entry)
	{ ::WritePrivateProfileString(section, entry, NULL, m_iniFilePath.c_str()); }
	void DeleteSection(LPCSTR section)
	{ ::WritePrivateProfileString(section, NULL, NULL, m_iniFilePath.c_str()); }

	void EscapeIniStr(LPCTSTR in, tstring &out);
	void UnescapeIniStr(LPCTSTR in, tstring &out);
};
