#include "stdafx.h"
#include "ListView.h"
#include <stdarg.h>
#include <commctrl.h>



//*******************************************************************
// RXgN^EfXgN^
//*******************************************************************
CListView::CListView(void)
{
}

CListView::~CListView(void)
{
}

//*******************************************************************
// 
//*******************************************************************

void CListView::AddColumn(int index, DWORD fmt, LPCSTR name, int width) const
{
	LVCOLUMN lvc;

	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_SUBITEM | LVCF_TEXT;
	lvc.fmt = fmt;
	lvc.pszText = (LPSTR)name;
	lvc.cx = width;
	lvc.iSubItem = index;
	ListView_InsertColumn(m_hWnd, index, &lvc);
}

void CListView::SetExViewStyle(DWORD style) const
{
	ListView_SetExtendedListViewStyle(m_hWnd, style);
}

void CListView::SelectItem(int iItem) const
{
	ListView_SetItemState(m_hWnd, iItem, LVIS_SELECTED, LVIS_SELECTED);
	ListView_SetSelectionMark(m_hWnd, iItem);
}

void CListView::ClearAllItem() const
{
	ListView_DeleteAllItems(m_hWnd);
}

void CListView::InsertItem(int iItem, LPCSTR value, LPARAM data) const
{
	LVITEM lvi;

	lvi.mask = LVIF_TEXT | LVIF_PARAM;
	lvi.iItem = iItem;
	lvi.iSubItem = 0;
	lvi.pszText = (LPSTR)value;
	lvi.lParam = data;
	ListView_InsertItem(m_hWnd, &lvi);
}

void CListView::InsertSubItem(int iItem, int iSub, LPCSTR value) const
{
	ListView_SetItemText(m_hWnd, iItem, iSub, (LPSTR)value);
}

LPARAM CListView::GetItemData(int iItem, LPARAM fail) const
{
	LVITEM lvi;
	BOOL ret;

	lvi.mask = LVIF_PARAM;
	lvi.iItem = iItem;
	lvi.iSubItem = 0;
	ret = ListView_GetItem(m_hWnd, &lvi);

	return ret ? lvi.lParam: fail;
}

void CListView::InsertItemLine(int iItem, int nSubItem, LPCSTR value, ...) const
{
	va_list args;

	InsertItem(iItem, value);

	va_start(args, value);
	for( int i = 1; i < nSubItem; ++i )
		InsertSubItem(iItem, i, va_arg(args, LPCSTR));
	va_end(args);
}

int CListView::GetCurSel() const
{
	return ListView_GetSelectionMark(m_hWnd);
}

void CListView::AutosizeColumn(int num) const
{
	for( int i = 0; i < num; ++i ){
		ListView_SetColumnWidth(m_hWnd, i, LVSCW_AUTOSIZE_USEHEADER);
	}
}

void CListView::SetCheck(int iItem, bool check) const
{
	ListView_SetCheckState(m_hWnd, iItem, check);
}

bool CListView::GetCheck(int iItem) const
{
	return ListView_GetCheckState(m_hWnd, iItem) != 0;
}

int CListView::GetItemCount() const
{
	return ListView_GetItemCount(m_hWnd);
}

void CListView::GetItemText(int iItem, int iSub, LPSTR buf, int size) const
{
	ListView_GetItemText(m_hWnd, iItem, iSub, buf, size);
}


