#pragma once

class CListView
{
private:
	HWND m_hWnd;

public:
	CListView();
	~CListView();

	void AddColumn(int index, DWORD fmt, LPCSTR name, int width) const;
	void SetExViewStyle(DWORD style) const;
	void SelectItem(int iItem) const;
	void ClearAllItem() const;
	void InsertItem(int iItem, LPCSTR value, LPARAM data=NULL) const;
	void InsertSubItem(int iItem, int iSub, LPCSTR value) const;
	void InsertItemLine(int iItem, int nSubItem, LPCSTR value, ...) const;
	LPARAM GetItemData(int iItem, LPARAM fail) const;
	int GetCurSel() const;
	void AutosizeColumn(int num) const;
	void SetCheck(int iItem, bool check) const;
	bool GetCheck(int iItem) const;
	int GetItemCount() const;
	void GetItemText(int iItem, int iSub, LPSTR buf, int size) const;

	void SetWndHandle(HWND hWnd)
	{ m_hWnd = hWnd; }

private:
	LRESULT SendMessage(UINT msg, WPARAM wParam=0, LPARAM lParam=0)
	{ ::SendMessage(m_hWnd, msg, wParam, lParam); }
};
