#pragma once

template <typename T>
class CLockableItem
{
public:
	typedef T LockTarget;

protected:
	T m_item;
	CRITICAL_SECTION m_lock;

public:
	CLockableItem(void);
	~CLockableItem(void);

	T& Lock()
	{
		::EnterCriticalSection(&m_lock);
		return m_item;
	}
	void Unlock()
	{
		::LeaveCriticalSection(&m_lock);
	}
};
