#pragma once
#include "nsmsgs.h"

//*************************************************************************
#define DEFINE_SERVICE2(name, param1type, param2type) \
	static int __stdcall Service##name(WPARAM wParam, LPARAM lParam) \
		{ return GetInstance().Do##name((param1type)wParam, (param2type)lParam); }

#define DEFINE_SERVICE1(name, param1type) \
	static int __stdcall Service##name(WPARAM wParam, LPARAM /*lParam*/) \
		{ return GetInstance().Do##name((param1type)wParam); }

#define DEFINE_SERVICE0(name) \
	static int __stdcall Service##name(WPARAM /*wParam*/, LPARAM /*lParam*/) \
		{ return GetInstance().Do##name(); }

#define DEFINE_EVENTHOOK2(name, param1type, param2type) \
	static int __stdcall Hook##name(WPARAM wParam, LPARAM lParam) \
		{ return GetInstance().On##name((param1type)wParam, (param2type)lParam); }

#define DEFINE_EVENTHOOK1(name, param1type) \
	static int __stdcall Hook##name(WPARAM wParam, LPARAM /*lParam*/) \
		{ return GetInstance().On##name((param1type)wParam); }

#define DEFINE_EVENTHOOK0(name) \
	static int __stdcall Hook##name(WPARAM /*wParam*/, LPARAM /*lParam*/) \
		{ return GetInstance().On##name(); }

//*************************************************************************

#define HANDLE_GETCAPTION(pinfo, cap)						\
	case NMUI_GETCAPTION:									\
		wcsncpy_s(											\
			(wchar_t*)(pinfo)->lpInfo->lpBuffer,			\
			(pinfo)->lpInfo->nBufferSize/sizeof(wchar_t),	\
			(cap),											\
			(pinfo)->lpInfo->nBufferSize/sizeof(wchar_t)	\
		);													\
		(pinfo)->lpInfo->nType = NMIT_WIDESTRING;			\
		break;

//*************************************************************************

#ifdef __cplusplus
extern "C" {
#endif

int __declspec(dllexport) __stdcall GetPluginInfo(int nInfoNo, LPTSTR lpBuffer, int nSize);
int __declspec(dllexport) __stdcall Initialize(PNsmPluginInitInfo lpInitInfo);
int __declspec(dllexport) __stdcall Terminate();

#ifdef __cplusplus
}
#endif

//*************************************************************************
class CNsmPlugin
{
// singleton -->
private:
	static CNsmPlugin* m_psingleton;
// RXgN^EfXgN^
protected:
	CNsmPlugin(void);
public:
	~CNsmPlugin(void);

public:
	static CNsmPlugin& GetInstance()
	{
		_ASSERT(m_psingleton != NULL);
		return *m_psingleton; 
	}
// <-- singleton

private:
	static HINSTANCE m_hInstance;

public:
	static void SetModuleInstance(HINSTANCE hInst)
	{
		_ASSERT( m_hInstance == NULL );
		_ASSERT( hInst != NULL );
		m_hInstance = hInst;
	}
	static HINSTANCE GetModuleInstance()
	{
		_ASSERT( m_hInstance != NULL );
		return m_hInstance;
	}

protected:
	LPCSTR m_pApiVer;
	LPCSTR m_pModuleName;
	LPCSTR m_pTitle;
	LPCSTR m_pDescription;
	LPCSTR m_pAuthor;
	LPCSTR m_pCopyright;
	LPCSTR m_pPluginVer;

// I[o[Ch]
public:
	// vOCK{֐
	virtual int GetPluginInfo( int nInfoNo, LPTSTR lpBuffer, int nSize );
	virtual int Initialize( PNsmPluginInitInfo lpNsmInitInfo );
	virtual int OnInitialize();
	virtual int Terminate();
	virtual void OnTerminate();

	DEFINE_EVENTHOOK0(SystemModulesLoaded);

	virtual int OnSystemModulesLoaded();

};
