#include "stdafx.h"
#include "PPage.h"
#include "mleak.h"
#pragma comment(lib, "comctl32.lib")

#ifdef  __cplusplus
extern "C" {
#endif
	void *          __cdecl _alloca(size_t);
#ifdef  __cplusplus
}
#endif

//******************************************************************
// 
//******************************************************************
CPPage::CPPage(void)
: m_nIDTemplate(0)
, m_bApply(false)
, m_pTitle(NULL)
{
}

CPPage::~CPPage(void)
{
}

//******************************************************************
// 
//******************************************************************
HPROPSHEETPAGE CPPage::Create(HINSTANCE hInstance)
{
	_ASSERT( m_nIDTemplate != 0 );
	PROPSHEETPAGE psp;

	m_hInstance = hInstance;
	psp.dwSize = sizeof(psp);
	psp.dwFlags = (PSP_DEFAULT);
	psp.hInstance = hInstance;
	psp.pszTemplate = MAKEINTRESOURCE(m_nIDTemplate);
	psp.pfnDlgProc = DlgProc;
	psp.lParam = (LPARAM)this;
	if( m_pTitle != NULL ){
		psp.dwFlags |= PSP_USETITLE;
		psp.pszTitle = m_pTitle;
	}

	return ::CreatePropertySheetPage(&psp);
}

//******************************************************************
// 
//******************************************************************
BOOL CPPage::Attach(HWND hWnd)
{
	m_hDlgWnd = hWnd;
	return InitDlgCtrl();
}

BOOL CPPage::DlgProc(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/)
{
	return FALSE;
}

// _CAORg[
BOOL CPPage::InitDlgCtrl()
{
	return TRUE;
}

// _CAORg[̒l擾
void CPPage::GetDlgCtrlValue()
{
}

// _CAORg[̒l擾
void CPPage::UpdateDlgCtrl()
{
}

//******************************************************************
// 
//******************************************************************
LPTSTR CPPage::GetEditBoxText(HWND hItem) const
{
	LPTSTR newStr;
	int len;

	len = ::GetWindowTextLength(hItem) + 1;
	newStr = new TCHAR[len];
	::GetWindowText(hItem, newStr, len);

	return newStr;
}

void CPPage::GetEditBoxText(HWND hItem, std::string &text) const
{
	LPTSTR newStr;
	int len;

	len = ::GetWindowTextLength(hItem) + 1;
	newStr = (LPTSTR)_alloca(len);
	::GetWindowText(hItem, newStr, len);

	text = newStr;
}

int CPPage::GetEditBoxInt(HWND hItem) const
{
	LPTSTR str;
	int len;

	len = ::GetWindowTextLength(hItem) + 1;
	str = (LPTSTR)_alloca(len);
	::GetWindowText(hItem, str, len);
	return atoi(str);
}

//******************************************************************
// 
//******************************************************************

//******************************************************************
// 
//******************************************************************

//******************************************************************
// 
//******************************************************************

//******************************************************************
// 
//******************************************************************

BOOL CALLBACK CPPage::DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	if( uMsg == WM_INITDIALOG )
	{
		PROPSHEETPAGE &psp = *(PROPSHEETPAGE*)lParam;

		::SetWindowLongPtr(hWnd, GWL_USERDATA, static_cast<LONG_PTR>(psp.lParam));
		return ((CPPage*)psp.lParam)->Attach(hWnd);
	}
	else
	{
		CPPage* pPPage = reinterpret_cast<CPPage*>(static_cast<LONG_PTR>(::GetWindowLongPtr(hWnd, GWL_USERDATA)));

		if( pPPage != NULL ){
			if( uMsg == WM_NOTIFY ){
				switch( ((NMHDR *)lParam)->code ){
				case PSN_APPLY:
					pPPage->m_bApply = true;
					// no break
				case PSN_KILLACTIVE:
					pPPage->GetDlgCtrlValue();
					return TRUE;
				case PSN_SETACTIVE:
					pPPage->UpdateDlgCtrl();
					return TRUE;
				}
			}
			return pPPage->DlgProc(uMsg, wParam, lParam);
		}
	}

	return FALSE;
}
