#pragma once
#include <string>
#include <prsht.h>
#include "ToolTip.h"

class CPPage
{
protected:
	HINSTANCE m_hInstance;
	HWND m_hDlgWnd;
	UINT m_nIDTemplate;
	bool m_bApply;
	LPCSTR m_pTitle;

public:
	// RXgN^EfXgN^
	CPPage(void);
	virtual ~CPPage(void);

	HPROPSHEETPAGE Create(HINSTANCE hInstance);
	bool IsApplied() const
	{ return m_bApply; }

protected:
	BOOL Attach(HWND hWnd);

// Rg[
protected:
	LPTSTR GetEditBoxText(HWND hItem) const;
	void GetEditBoxText(HWND hItem, std::string &text) const;
	int GetEditBoxInt(HWND hItem) const;

	LPTSTR GetEditBoxText(int nID) const
	{ GetEditBoxText(GetDlgItem(nID)); }
	void GetEditBoxText(int nID, std::string &text) const
	{ GetEditBoxText(GetDlgItem(nID), text); }
	int GetEditBoxInt(int nID) const
	{ return GetEditBoxInt(GetDlgItem(nID)); }
	bool SetEnable(int nID, BOOL bEnable) const
	{ return EnableWindow(GetDlgItem(nID), bEnable) != FALSE; }
	BOOL SetVisible(int nID, bool bVisible) const
	{ return ::ShowWindow(GetDlgItem(nID), bVisible ? SW_SHOW: SW_HIDE); }

	void SetCheck(int nID, BOOL bState) const
	{
		::SendMessage(GetDlgItem(nID), BM_SETCHECK,
			(WPARAM)(bState ? BST_CHECKED: BST_UNCHECKED), NULL);
	}
	bool GetCheck(int nID) const
	{
		return BST_CHECKED == ::SendMessage(GetDlgItem(nID),
									BM_GETCHECK, NULL, NULL);
	}
	void SetItemText(int nID, LPCSTR str) const
	{ ::SetWindowText(GetDlgItem(nID), str); }
	void SetItemText(int nID, int n) const
	{
		char buf[32];
		_itoa_s(n, buf, 10);
		::SetWindowText(GetDlgItem(nID), buf);
	}
	void SetEditBoxText(int nID, LPCTSTR str) const
	{ SetItemText(nID, str); }
	HWND GetDlgItem(int nID) const
	{ return ::GetDlgItem(m_hDlgWnd, nID); }

// I[o[Ch]
protected:
	// _CAOvV[W
	virtual BOOL DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
	virtual BOOL InitDlgCtrl();
	virtual void GetDlgCtrlValue();
	virtual void UpdateDlgCtrl();

// _CAOvV[W
private:
	static BOOL CALLBACK DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
};
