#include "stdafx.h"
#include <prsht.h>
#include "PSheet.h"
#include "DynamicArray.h"
#include "mleak.h"
#pragma comment(lib, "comctl32.lib")

//******************************************************************
// 
//******************************************************************
CPSheet::CPSheet(void)
{
}

CPSheet::~CPSheet(void)
{
}

//******************************************************************
// 
//******************************************************************
bool CPSheet::DoModal(HINSTANCE hInstance, HWND hWnd, LPCSTR lpTitle)
{
	PropertySheet(hInstance, hWnd, lpTitle, false);
	for( PPageList::iterator i = m_ppages.begin(); i != m_ppages.end(); ++i )
		if( (*i)->IsApplied() ) return true;

	return false;
}

//******************************************************************
// 
//******************************************************************

int CPSheet::PropertySheet(HINSTANCE hInstance, HWND hWnd, LPCSTR lpTitle, bool bModeless)
{
	_ASSERT( m_ppages.size() > 0 );
	PROPSHEETHEADER psh;
	DynamicArray<HPROPSHEETPAGE> ppages(m_ppages.size());

	for( int i = 0; i < (int)m_ppages.size(); i++ )
		ppages[i] = m_ppages[i]->Create(hInstance);

	psh.dwSize = sizeof(psh);
	psh.dwFlags = (PSH_NOAPPLYNOW|PSH_NOCONTEXTHELP);
	psh.hwndParent = hWnd;
	psh.hInstance = hInstance;
	psh.pszCaption = lpTitle;
	psh.nPages = static_cast<UINT>(m_ppages.size());
	psh.nStartPage = 0;
	psh.phpage = ppages;

	if( bModeless ) psh.dwFlags |= PSH_MODELESS;

	return static_cast<int>(::PropertySheet(&psh));
}

