#pragma once

template <typename T>
class CPtrCtnrItem
{
protected:
	typedef CPtrCtnrItem<T> Self;

protected:
	T* m_ptr;

public:
	CPtrCtnrItem(T* p)
		: m_ptr(p)
	{
	}
	CPtrCtnrItem(const Self &right)
		: m_ptr(right.m_ptr)
	{
		const_cast<Self&>(right).m_ptr = NULL;
	}
	~CPtrCtnrItem(void)
	{
		delete m_ptr;
	}
	bool operator == (const T* right)
	{
		return m_ptr == right;
	}
	T& operator *()
	{
		return m_ptr;
	}
	const T& operator *() const
	{
		return m_ptr;
	}
	T* operator ->()
	{
		return m_ptr;
	}
	const T* operator ->() const
	{
		return m_ptr;
	}

private:
	const Self& operator =(Self& right);
};
