#pragma once
#include <commctrl.h>

class CToolTip
{
protected:
	HWND m_hWnd;

public:
	CToolTip()
	{
		m_hWnd = NULL;
	}
	~CToolTip()
	{
		if( m_hWnd != NULL ){
			::DestroyWindow(m_hWnd);
		}
	}

	void Create(HINSTANCE hInst, HWND hParent)
	{
		m_hWnd = ::CreateWindowEx(
			NULL, TOOLTIPS_CLASS, NULL,
			WS_POPUP | TTS_NOPREFIX,
			CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
			hParent, NULL, hInst, NULL);

		if( m_hWnd != INVALID_HANDLE_VALUE )
			::SetWindowPos(m_hWnd, HWND_TOPMOST, 0, 0, 0, 0,
				SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
	}
	void Begin(int nAutoPop=32767, int nInitial=100, int nReshow=0)
	{
		::SendMessage(m_hWnd, TTM_SETDELAYTIME, TTDT_AUTOPOP, nAutoPop);
		::SendMessage(m_hWnd, TTM_SETDELAYTIME, TTDT_INITIAL, nInitial);
		::SendMessage(m_hWnd, TTM_SETDELAYTIME, TTDT_RESHOW, nReshow);
		::SendMessage(m_hWnd, TTM_ACTIVATE, TRUE, 0);
	}

	// ʂ̃Rg[piRg[̃EChEnhƕ\[XIDj
	void AddToolToToolTip(HINSTANCE hInst, HWND hParent, HWND hCtrl, UINT nStrID)
	{
		TOOLINFO ti;

		ti.cbSize = sizeof(ti);
		ti.uFlags = TTF_IDISHWND|TTF_SUBCLASS;
		ti.hwnd = hParent;
		ti.uId = reinterpret_cast<UINT_PTR>(hCtrl);
//		tl.rect
		ti.hinst = hInst;
		ti.lpszText = MAKEINTRESOURCE(nStrID);
		::SendMessage(m_hWnd, TTM_ADDTOOL, 0, (LPARAM)&ti);
	}

	void AddToolToToolTip(HWND hParent, HWND hCtrl, UINT nStrID)
	{
		TOOLINFO ti;

		ti.cbSize = sizeof(ti);
		ti.uFlags = TTF_IDISHWND|TTF_SUBCLASS;
		ti.hwnd = hParent;
		ti.uId = reinterpret_cast<UINT_PTR>(hCtrl);
//		tl.rect
		ti.hinst = NULL;
		ti.lpszText = LPSTR_TEXTCALLBACK;
		ti.lParam = nStrID;
		::SendMessage(m_hWnd, TTM_ADDTOOL, 0, (LPARAM)&ti);
	}

	// ̈piOnDemandj
	//  hTool: ̈EChẼnhiTTN_GETDISPINFOւ̑ΉKvj
	//  itemRect: Ώۗ̈
	//  data: iTTN_GETDISPINFOœnf[^j
	//  
	//  
	//  
	//  

	void AddToolToToolTip(HWND hTool, RECT &itemRect, LPARAM data)
	{
		TOOLINFO ti;

		ti.cbSize = sizeof(ti);
		ti.uFlags = TTF_SUBCLASS;
		ti.hwnd = hTool;
		ti.uId = reinterpret_cast<UINT_PTR>(hTool);
		ti.rect = itemRect;
		ti.lpszText = LPSTR_TEXTCALLBACK;
		ti.lParam = data;
		::SendMessage(m_hWnd, TTM_ADDTOOL, 0, (LPARAM)&ti);
	}


};
