#pragma once
#include <string>

#define JPN_CODE_PAGE	932

int ToUnicode(UINT from, LPCSTR in, std::wstring &out);
int UnicodeTo(UINT to, LPCWSTR in, std::string &out);
inline int SJIStoUnicode(LPCSTR in, std::wstring &out)
{
	return ToUnicode(JPN_CODE_PAGE, in, out);
}

inline int UnicodeToSJIS(LPCWSTR in, std::string &out)
{
	return UnicodeTo(JPN_CODE_PAGE, in, out);
}

inline int UnicodeToUTF8(LPCWSTR in, std::string &out)
{
	return UnicodeTo(CP_UTF8, in, out);
}

inline int UTF8toUnicode(LPCSTR in, std::wstring &out)
{
	return ToUnicode(CP_UTF8, in, out);
}

inline int UnicodeToUTF7(LPCWSTR in, std::string &out)
{
	return UnicodeTo(CP_UTF7, in, out);
}

inline int UTF7toUnicode(LPCSTR in, std::wstring &out)
{
	return ToUnicode(CP_UTF7, in, out);
}

bool IsJIS(LPCSTR st, LPCSTR ed);
LPSTR JIStoSJIS(LPSTR out, LPCSTR in_st, LPCSTR in_ed);

void SJIStoJIS(LPCSTR sjis, std::string &jis);
int JisStrLenFromSjis(LPCSTR sjis);
