#pragma once
#include <string>
#include <list>

void LinkURL(std::wstring &out, LPCWSTR in);
int CreateDirAll(LPCTSTR lpPath);
LPTSTR DuplicateString(LPCTSTR str);
void FilePathFromFilePath(LPSTR buf, LPCSTR fromPath, LPCSTR file);
bool FileExists(LPCSTR path);
BOOL Rename(LPCSTR lpOld, LPCSTR lpNew);
void EscapeForHTML(std::wstring &out, LPCWSTR in);
void EscapeForHTML(std::string &out, LPCSTR in);

void UnicodeToHex(LPCWSTR in, std::string* out);
void HexToUnicode(LPCSTR in, std::wstring* out);

enum{
	CDA_OK,
	CDA_CANT_MAKE_DIR,
	CDA_CANT_GET_ATTR,
	CDA_NOT_DIR,
};


template <typename ElemT>
inline typename std::list<ElemT>::iterator ListGetAt(std::list<ElemT> &list, unsigned int index)
{
	typename std::list<ElemT>::iterator i;

	// ߂H
	if( index < (list.size() / 2) ){
		i = list.begin();
		for( unsigned int cnt = 0; cnt < index; ++cnt )
			++i;
	}else{
		i = list.end();
		for( unsigned int cnt = list.size(); cnt > index; --cnt )
			--i;
	}

	return i;
}
